#define FogRange 8 //[2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 18 20 22 24 26 28 30 32 36 40 44 48 52 56 60 64]

vec3 getFogColor(vec3 fragpos, vec3 light){
vec3 fog_col = fog_c;
vec3 nfragpos = normalize(fragpos);
float lfragpos = length(fragpos)/64.0;
lfragpos /= 1.0+lfragpos;

float NdotS = dot(nfragpos,sunVec)*0.5+0.5;

float lightmix = NdotS*(1.0-sqrt(tB))*sunVisibility*(1.0-rainStrength)*lfragpos*eBS;

fog_col = (mix(fog_col*pow(max(1-lightmix,0.0),2.0),pow(light,vec3(1.5)),lightmix)*sunVisibility + light_n*0.4)*1.2;
fog_col = mix(fog_col,sky_r*(0.035+0.455*sunVisibility),rainStrength)*0.5;

return pow(fog_col,vec3(1.15));
}

vec3 calcNormalFog(vec3 color, vec3 fragpos, vec3 light){
float fog = length(fragpos)/(16.0*FogRange*(1.0+sunVisibility));
return mix(color,getFogColor(fragpos,light),min(fog*eBS*(0.125+0.875*rainStrength),1.0));
}

vec3 calcWaterFog(vec3 color, vec3 fragpos, vec3 wcol, float wstr, float fogrange){
float fog = min(length(fragpos)/(fogrange*(1.0+3.0*eBS)),1.0);
return mix(color,pow(wcol*pow(wstr,0.75),vec3(2.2)),fog);
}

vec3 calcBlindFog(vec3 color, vec3 fragpos, float blindness){
	float b = clamp(blindness*2.0-1.0,0.0,1.0);
	b = b*b;
	float fog = pow(min(length(fragpos)/(5.0/b),1.0),1.0/2.2)*b;
	return mix(color,vec3(0.0),fog);
}

vec3 calcLavaFog(vec3 color, vec3 fragpos){
	float fog = min(length(fragpos)/(2.0),1.0);
	return mix(color,vec3(1.0,0.3,0.01),fog);
}

vec3 calcFog(vec3 color, vec3 fragpos, vec3 light, vec3 wcol, float wstr, float fogrange, float blindness){
	color = calcNormalFog(color, fragpos, light);
	if (isEyeInWater == 1.0) color = calcWaterFog(color, fragpos, wcol, wstr, fogrange);
	if (isEyeInWater == 2.0) color = calcLavaFog(color, fragpos);
	if (blindness > 0.0) color = calcBlindFog(color, fragpos, blindness);
	return color;
}