#define MotionBlurStrength 1.00 //[0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.00]

vec3 motionBlur (vec3 color, float coc, float hand){
	float motionblur  = texture2D(depthtex1, texcoord.st).x;
	vec3 mblur = color;
	float mbwg = 1.0;
	float mbm = 0.0;
	vec2 pixel = 2.0/vec2(viewWidth,viewHeight);
	
	vec4 currentPosition = vec4(texcoord.x * 2.0 - 1.0, texcoord.y * 2.0 - 1.0, 2.0 * motionblur - 1.0, 1.0);
	
	vec4 fragposition = gbufferProjectionInverse * currentPosition;
	fragposition = gbufferModelViewInverse * fragposition;
	fragposition /= fragposition.w;
	fragposition.xyz += cameraPosition;
	
	vec4 previousPosition = fragposition;
	previousPosition.xyz -= previousCameraPosition;
	previousPosition = gbufferPreviousModelView * previousPosition;
	previousPosition = gbufferPreviousProjection * previousPosition;
	previousPosition /= previousPosition.w;

	vec2 velocity = (currentPosition - previousPosition).xy;
	velocity = velocity/(1.0+length(velocity))*MotionBlurStrength*0.00025/frameTime;
	
	vec2 coord = texcoord.st-velocity*8.0;
	for (int i = 0; i < 17; ++i, coord += velocity) {
		if(hand < 0.5){
			vec2 coordb = clamp(coord,pixel,1.0-pixel);
			vec3 temp = texture2D(colortex0, coordb).rgb;
			mblur += temp;
			mbwg += 1.0;
		}
	}
	mblur /= mbwg;
	mblur = mix(color,mblur,mbwg/17);

	return mix(mblur,color,coc);
}